# CourseBuilder

Coursebuilder is a preprocessor tool for [pandoc](https://pandoc.org) 
to generate multi-lingual curricula documentation tables from 
structured representations as a flatfile database. Data scheme and 
actual values are kept in YAML files in order to version them with git.

## Usage

```sh
usage:  [-h] [-m META [META ...]] [-l LANG] [-f FIELDS [FIELDS ...]] [-s SCHEMA] [-q QUERY] [-qs QUERY_SORT] [-qc QUERY_COMPOUND] [-qf QUERY_FILTER [QUERY_FILTER ...]]
        [-p] [--title TITLE] [-b BOOK] [--level LEVEL] [--table-gen TABLE_GEN] [--template TEMPLATE] [-o OUT] [--legacy] [--leftcol LEFTCOL]

versatile curricula generator

options:
  -h, --help            show this help message and exit
  -m META [META ...], --meta META [META ...]
                        course description(s) as YAML file(s)
  -l LANG, --lang LANG  Language to parse from meta file (use de or en)
  -f FIELDS [FIELDS ...], --fields FIELDS [FIELDS ...]
                        Fields to be used, the table will be build accordingly
  -s SCHEMA, --schema SCHEMA
                        using provided schema
  -q QUERY, --query QUERY
                        compound query to select items
  -qs QUERY_SORT, --query-sort QUERY_SORT
                        sort query with a min/max over a column like min:credits
  -qc QUERY_COMPOUND, --query-compound QUERY_COMPOUND
                        create a compound from a column with multiple values/dictionaries in cells
  -qf QUERY_FILTER [QUERY_FILTER ...], --query-filter QUERY_FILTER [QUERY_FILTER ...]
                        filter final list of columns for output
  -p, --pagebreak       add a pagebreak after each module
  --title TITLE         template for title - use curly brackets (i.e. {}) to mark where the title string is inserted
  -b BOOK, --book BOOK  process a whole curriculum book with sections
  --level LEVEL         level of header tags
  --table-gen TABLE_GEN
                        runs table generator
  --template TEMPLATE   defines a template to be used with fields
  -o OUT, --out OUT     set the output type
  --legacy              use legacy generator mode for compatibility
  --leftcol LEFTCOL     maximum size of left column
```

## Author

&copy; Copyright 2020-2024 Hartmut Seichter

## Licence

Coursebuilder is licensed under the terms of the MIT License. For details consult https://opensource.org/license/mit/ or the attached license file

